/* ****************************************************************************
   **                                                                        **
   **                              SOLITAIRE                                 **
   **                                                                        **
   **           (c) 26/08/2001  par FlashCode (Sebastien HELLEU)             **
   **                                                                        **
   **                         http://www.flashtux.org                        **
   **                         e-mail:flashcode@flashtux.org                  **
   **                                                                        **
   ****************************************************************************
   Pour compiler (sous Linux):
        gcc -O6 -m486 -o solit solit.c

==== This program is free software; you can redistribute it and/or modify
==== it under the terms of the GNU General Public License as published by
==== the Free Software Foundation; either version 2 of the License, or
==== (at your option) any later version.
====
==== This program is distributed in the hope that it will be useful,
==== but WITHOUT ANY WARRANTY; without even the implied warranty of
==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
==== GNU General Public License for more details.
====
==== You should have received a copy of the GNU General Public License
==== along with this program; if not, write to the Free Software
==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@flashtux.org>
Creation: 12/10/1998

26/08/2001: FlashCode:
    - ajout de la licence
    - reecriture du source
*/

static char id[] = "$Id: SOLIT (c) Copyright 2001/08/26 by FlashCode <flashcode@free.fr> $";


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <termios.h>
#include <stdarg.h>

#ifdef MSDOS
    #include <conio.h>
#else
    #include <unistd.h>
#endif

/* pour debugger: */
#undef AFFICHE_BILLES

#define HAUT        0
#define BAS         1
#define GAUCHE      2
#define DROITE      3


int             etat[7][7];
int             nb_billes;
int             nb_billes_mini;
unsigned long   nb_comb;

unsigned char   car[50];

signed char     soucoupe[7][7] =
                {{ -1,-1, 0, 0, 0,-1,-1 },      /*              */
                 { -1, 0, 0, 1, 0, 0,-1 },      /*      *      */
                 {  0, 0, 1, 1, 1, 0, 0 },      /*    * * *    */
                 {  0, 1, 1, 1, 1, 1, 0 },      /*   * * * * *   */
                 {  0, 0, 1, 0, 1, 0, 0 },      /*    *  *    */
                 { -1, 0, 0, 0, 0, 0,-1 },      /*            */
                 { -1,-1, 0, 0, 0,-1,-1 }};     /*              */

unsigned char   chaine_billes[100];

int             lettre_dir[4] = { 'H', 'B', 'G', 'D' };
int             coups[100][3];
unsigned long   nb_coups;

struct termios  ot0, ot1, nt0, nt1;


/*
 * affiche_aide: affiche l'aide sur Solit
 */

void affiche_aide(char *argv[])
{
    printf("\nSOLIT  (c) Copyright 26/08/2001 par FlashCode (Sebastien Helleu)\n");
    printf("           Disponible pour Linux/Dos/Windows\n\n");
    printf("%s -licence : affiche la licence de SOLIT.\n\n", argv[0]);
    exit(0);
}

/*
 * affiche_licence: affiche la licence de NB2L
 */

void affiche_licence()
{
    printf("\nSOLIT  (c) Copyright 1998,1999,2000,2001 by FlashCode (Sebastien Helleu)\n\n");
    printf("This program is free software; you can redistribute it and/or modify\n");
    printf("it under the terms of the GNU General Public License as published by\n");
    printf("the Free Software Foundation; either version 2 of the License, or\n");
    printf("(at your option) any later version.\n");
    printf("\n");
    printf("This program is distributed in the hope that it will be useful,\n");
    printf("but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
    printf("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
    printf("GNU General Public License for more details.\n");
    printf("\n");
    printf("You should have received a copy of the GNU General Public License\n");
    printf("along with this program; if not, write to the Free Software\n");
    printf("Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n\n");
    exit(0);
}

/*
 * init_ecran_ansi: initialise l'affichage par Ansi (Linux seulement)
 */

#ifndef MSDOS
void init_ecran_ansi()
{
    tcgetattr(1, &ot1); tcgetattr(1, &nt1);

    nt1.c_lflag = 0;
    nt1.c_iflag = 0;
    nt1.c_oflag = 0;
    nt1.c_cc[VMIN] = 1;
    nt1.c_cc[VTIME] = 0;

    tcsetattr(1, TCSANOW, &nt1);
}
#endif

/*
 * deinit_ecran_ansi: restaure l'affichage sans Ansi (Linux seulement)
 */

#ifndef MSDOS
void deinit_ecran_ansi()
{
    tcsetattr(1, TCSANOW, &ot1);
}
#endif

/*
 * print_xy: affiche une chaine aux coordonnees (x,y) par Ansi
 */

void print_xy(int x, int y, unsigned char *chaine, ...)
{
    unsigned char   buffer[81], buffer2[121];
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    sprintf(buffer2, "\x1b[%i;%iH%s", y, x, buffer);
    write(1, buffer2, strlen(buffer2));
}

/*
 * prepare_etats: prepare les etats des cases du solitaire
 */

void prepare_etats()
{
    int   i, j;

    for (i = 0; i < 7; i++)
        for (j = 0; j < 8; j++)
            etat[i][j] = 1;
    for (i = 0; i < 2; i++)
    {
        etat[i][0] = -1;
        etat[6-i][0] = -1;
        etat[i][6] = -1;
        etat[6-i][6] = -1;
    }
    etat[0][1] = -1; etat[6][1] = -1;
    etat[0][5] = -1; etat[6][5] = -1;
    etat[3][3] = 0;                         /* retire la bille du milieu */

    /*etat[1][1] = -1; etat[5][1] = -1;*/   /* test : solitaire en "+"   */
    /*etat[1][5] = -1; etat[5][5] = -1;*/   /* test : solitaire en "+"   */

    nb_billes = 36;
    /*nb_billes = 32;*/

    nb_comb = 0;
    strcpy(chaine_billes,
        "       \r\n       \r\n       \r\n       \r\n       \r\n       \r\n       ");
    nb_billes_mini = 99;
}

/*
 * affiche_billes: affiche les billes (pour debugger)
 */

#ifdef AFFICHE_BILLES
void affiche_billes()
{
    int     i, j;

    for (i = 0; i < 7; i++)
        for (j = 0; j < 7; j++)
            switch (etat[i][j])
            {
                case -1:
                    chaine_billes[j*9+i] = ' ';
                    break;
                case 0:
                    chaine_billes[j*9+i] = '';
                    break;
                case 1:
                    chaine_billes[j*9+i] = 'o';
                    break;
            }
    print_xy(1, 1, "%s", chaine_billes);
}
#endif

/*
 * affiche_nb_comb: affiche le nombre de combinaisons actuellement testees
 *                  lorsque le signal SIGUSR1 est recu
 */

void affiche_nb_comb()
{
    printf("Combinaisons testees: %lu\n", nb_comb);
    #ifndef MSDOS
    signal(SIGUSR1, affiche_nb_comb);
    #endif
}

/*
 * est_soucoupe: indique si la soucoupe est atteinte
 *               (a partir de cette soucoupe, on gagne sans probleme)
 *               Je pense que tester ca ralentit trop l'algorithme
 *               c'est pour ca que l'appel a cette fonction est en commentaire
 *               dans cherche_solution()
 */

int est_soucoupe()
{
    int     i, j;

    for (i = 0; i < 7; i++)
        for (j = 0; j < 7; j++)
            if (etat[i][j] != soucoupe[i][j])
                return 0;
    return 1;
}

/*
 * memo_coup: memorise un coup dans la pile des coups testes
 */

void memo_coup(int x, int y, int dir)
{
    coups[nb_coups][0] = x;
    coups[nb_coups][1] = y;
    coups[nb_coups][2] = dir;
    nb_coups++;
}

/*
 * affiche_solution: affiche la solution
 *                   J'aimerais bien que cette fonction soit appelee !!
 */

void affiche_solution()
{
    int     i;

    affiche_nb_comb();
    printf("Nombre de coups necessaires: %lu\n\n", nb_coups);
    for (i = 0; i < nb_coups; i++)
        printf("(%d,%d)%c ", coups[i][0], coups[i][1], lettre_dir[coups[i][2]]);
    printf("\n");
}

/*
 * cherche_solution: algorithme de recherche proprement dit
 *                   C'est la qu'il faut intervenir pour speeder un peu + !
 */

void cherche_solution()
{
    int     i, j;

    nb_comb++;

    #ifdef MSDOS
        if (kbhit())
        {
            if (getch() == 0) getch();
            affiche_nb_comb();
        }
    #endif
/*    if (nb_billes < nb_billes_mini)
    {
        nb_billes_mini = nb_billes;
        printf("Nb billes mini = %d\n", nb_billes_mini);
    } */
    #ifdef AFFICHE_BILLES
    read(0, car, 1);
    affiche_billes();
    print_xy(1, 11, "%u  ", nb_coups);
    if (nb_billes < nb_billes_mini)
        nb_billes_mini = nb_billes;
    print_xy(1, 15, "nb_billes_mini = %d   \n", nb_billes_mini);
    #endif
/*    if (nb_billes == 11)
        if (est_soucoupe())
        {
            printf("(SOUCOUPE) => TERMINE !!!!!!!!!!!!!!!!!!!!!!!!!\n");
            affiche_solution();
            exit(0);
        } */
/*        else
            exit();*/
    for (i = 0; i < 7; i++)
        for (j = 0; j < 7; j++)
            if (etat[i][j] == 1)
            {
                if ( (j <= 4) && (etat[i][j+1] == 1) && (etat[i][j+2] == 0) )
                {   /* bouffer vers le bas possible */
                    etat[i][j+2] = 1; etat[i][j+1] = 0; etat[i][j] = 0;
                    nb_billes--;
                    memo_coup(i, j, BAS);
                    cherche_solution();
                    nb_coups--;
                    etat[i][j+2] = 0; etat[i][j+1] = 1; etat[i][j] = 1;
                    nb_billes++;
                }
                if ( (i >= 2) && (etat[i-1][j] == 1) && (etat[i-2][j] == 0) )
                {   /* bouffer vers la gauche possible */
                    etat[i-2][j] = 1; etat[i-1][j] = 0; etat[i][j] = 0;
                    nb_billes--;
                    memo_coup(i, j, GAUCHE);
                    cherche_solution();
                    nb_coups--;
                    etat[i-2][j] = 0; etat[i-1][j] = 1; etat[i][j] = 1;
                    nb_billes++;
                }
                if ( (j >= 2) && (etat[i][j-1] == 1) && (etat[i][j-2] == 0) )
                {   /* bouffer vers le haut possible */
                    etat[i][j-2] = 1; etat[i][j-1] = 0; etat[i][j] = 0;
                    nb_billes--;
                    memo_coup(i, j, HAUT);
                    cherche_solution();
                    nb_coups--;
                    etat[i][j-2] = 0; etat[i][j-1] = 1; etat[i][j] = 1;
                    nb_billes++;
                }
                if ( (i <= 4) && (etat[i+1][j] == 1) && (etat[i+2][j] == 0) )
                {   /* bouffer vers la droite possible */
                    etat[i+2][j] = 1; etat[i+1][j] = 0; etat[i][j] = 0;
                    nb_billes--;
                    memo_coup(i, j, DROITE);
                    cherche_solution();
                    nb_coups--;
                    etat[i+2][j] = 0; etat[i+1][j] = 1; etat[i][j] = 1;
                    nb_billes++;
                }
            }
    /*printf("Sortie, il reste %u billes\n", nb_billes);*/
    if (nb_billes == 1)
    {
        /* On passe jamais la ??? Snif........ */
        printf("\n!!!!!!!!!!! SOLUTION pour laisser 1 bille !!!!!!!!!!!!!!\n");
        affiche_solution();
        exit(0);
    }
    #ifdef AFFICHE_BILLES
    affiche_billes();
    print_xy(1, 10, "Sortie, retour etat precedent");
    read(0, car, 1);
    print_xy(1, 10, "                             ");
    #endif
}

int main(int argc, char *argv[])
{
    if (argc == 2)
    {
        if (strcmp(argv[1], "-?") == 0)
            affiche_aide(argv);
        if (strcasecmp(argv[1], "-licence") == 0)
            affiche_licence();
    }
    #ifdef AFFICHE_BILLES
        #ifndef MSDOS
            init_ecran_ansi();
            print_xy(1, 1, "\x1b[2J\x1b[1;1H");  /* efface l'ecran */
        #endif
    #endif
    #ifndef MSDOS
        signal(SIGUSR1, affiche_nb_comb);
    #endif
    prepare_etats();
    cherche_solution();
    #ifdef AFFICHE_BILLES
        #ifndef MSDOS
            deinit_ecran_ansi();
        #endif
    #endif
    return 0;
}
